Subject: Re: [PATCHv2] Teach --no-ff option to 'rebase -i'.

From: Peter Baumann <[email-masked]>
Date: Wed, 17 Mar 2010 16:58:42 +0100

On Wed, Mar 17, 2010 at 07:59:19AM +0100, Johannes Sixt wrote:
> Jonathan Nieder schrieb:
> > If I am understanding properly, your idea is that this would be used on
> > a branch after “unmerging” it from master:
> > 
> >     B --- C --- D [topic]
> >   /              \
> >  A ---  ...   --- M ... --- U [master]
> > 
> > Here M is a merge commit and U a commit reverting the change from M^
> > to M.
> 
> If I were to re-merge topic into master a second time after this
> situation, I would install a temporary graft that removes the second
> parent of M and repeat the merge. After the graft is removed, the history
> would look like this:
> 
>      B --- C --- D --------------.   [topic]
>    /              \               \
>   A ---  ...   --- M ... --- U ... N [master]
> 
> Are there any downsides? I don't know - I haven't thought it through.
> 

Might be. If there is any branch starting anywhere in between M and U
which also needs to merge [topic] will also cause you headaches :-)

       B --- C --- D --------------.   [topic]
     /              \               \
    A ---  ...   --- M ... --- U ... N [master]
                         \
                          x --- y [side_branch wich needs to merge topic] 

--
Peter